/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160930-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt1.dat, Thu Nov 10 20:32:43 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000297 (663)
 *     Revision         0x02
 *     Checksum         0x8C
 *     OEM ID           "SgRef"
 *     OEM Table ID     "SgPeg"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("", "SSDT", 2, "SgRef", "SgPeg", 0x00001000)
{
    /*
     * iASL Warning: There were 3 external control methods found during
     * disassembly, but only 0 were resolved (3 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (_SB_.PCI0.PGOF, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.PGON, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (GBAS, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (PVID, UnknownObj)
    External (PWOK, UnknownObj)
    External (SGGP, UnknownObj)
    External (SGMD, UnknownObj)

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (SGON, 0, Serialized)
        {
            \_SB.PCI0.PGON (Zero)
            Return (Zero)
        }

        Method (SGOF, 0, Serialized)
        {
            \_SB.PCI0.PGOF (Zero)
            Return (Zero)
        }

        OperationRegion (LGPI, SystemIO, \GBAS (0x60), Field (LGPI, ByteAcc, Lock, Preserve)
            {
                Offset (0x0C), 
                LVL0,   32, 
                Offset (0x38), 
                LVL1,   32, 
                Offset (0x48), 
                LVL2,   32
            })
        Method (SGST, 0, Serialized)
        {
            If (SGMD & 0x0F)
            {
                If (SGGP != One)
                {
                    Return (0x0F)
                }

                If (SGPI (PWOK) == One)
                {
                    Return (0x0F)
                }

                Return (Zero)
            }

            If (PVID != 0xFFFF)
            {
                Return (0x0F)
            }

            Return (Zero)
        }

        Method (SGPI, 1, Serialized)
        {
            If (SGMD & 0x0F)
            {
                If (SGGP == One)
                {
                    Local1 = (Arg0 >> 0x07)
                    Arg0 &= 0x7F
                    If (Arg0 < 0x20)
                    {
                        Local0 = \_SB.PCI0.PEG0.PEGP.LVL0
                        Local0 >>= Arg0
                    }
                    ElseIf (Arg0 < 0x40)
                    {
                        Local0 = \_SB.PCI0.PEG0.PEGP.LVL1
                        Local0 >>= (Arg0 - 0x20)
                    }
                    Else
                    {
                        Local0 = \_SB.PCI0.PEG0.PEGP.LVL2
                        Local0 >>= (Arg0 - 0x40)
                    }

                    If (Local1 == Zero)
                    {
                        Local0 = ~Local0
                    }

                    Return ((Local0 & One))
                }
            }

            Return (Zero)
        }

        Method (SGPO, 2, Serialized)
        {
            If (SGMD & 0x0F)
            {
                If (SGGP == One)
                {
                    Local3 = (Arg0 >> 0x07)
                    Arg0 &= 0x7F
                    If (Local3 == Zero)
                    {
                        Local3 = ~Arg1
                        Local3 &= One
                    }
                    Else
                    {
                        Local3 = (Arg1 & One)
                    }

                    If (Arg0 < 0x20)
                    {
                        Local0 = (Local3 << Arg0)
                        Local1 = (One << Arg0)
                        Local2 = (\_SB.PCI0.PEG0.PEGP.LVL0 & ~Local1)
                        \_SB.PCI0.PEG0.PEGP.LVL0 = (Local2 | Local0)
                    }
                    ElseIf (Arg0 < 0x40)
                    {
                        Local0 = (Local3 << (Arg0 - 0x20))
                        Local1 = (One << (Arg0 - 0x20))
                        Local2 = (\_SB.PCI0.PEG0.PEGP.LVL1 & ~Local1)
                        \_SB.PCI0.PEG0.PEGP.LVL1 = (Local2 | Local0)
                    }
                    Else
                    {
                        Local0 = (Local3 << (Arg0 - 0x40))
                        Local1 = (One << (Arg0 - 0x40))
                        Local2 = (\_SB.PCI0.PEG0.PEGP.LVL2 & ~Local1)
                        \_SB.PCI0.PEG0.PEGP.LVL2 = (Local2 | Local0)
                    }

                    Return (One)
                }
            }

            Return (One)
        }
    }
}

